系统支持如下评判规则，精确匹配最为常用，其它根据题目的情形选用：

* 精确匹配  
这是最为常用的匹配方式，要求学生程序输出与期望输出完全一致。

为了降低格式的影响，系统自动去掉了行首与行尾的空白字符、以及空白行，进行对比。行内的空白字符（空格、制表符等）与期望结果不一致，会判为格式错误。

* 模糊匹配  
可以使用通配符 * 和 ? 表达期望输出，且大小写无关。 例如圆周率只需要保留3为小数， 期望输出为：3.141*；

“模糊匹配”也可以用于答案“多选一”的场景， 期望输出把所有可能的正确结果按行列出，用户程序的输出行，只要是期望输出的子集就判正确。

模糊匹配容易引起误判，可能把不正确的判为正确，请根据题目输出特点酌情考虑

应用案例1：正确答案可能是0~9中的任意一个或者几个数字，那么期望输出为：0~9按行列出。 应用案例2：地铁线路查询，只要找出一条就算结果正确，那么期望输出把所有的期望结果全部列出即可。

* LCS匹配  
LCS（最长公共子序列）匹配方法，能够得出一个测试用例的部分正确分， 利用LCS算法找出学生输出与期望输出的最长子串，最长子串与（期望输出和学生程序输出的最大值）的长度比值，得到一个正确率，假设为 r。

题目得分 = Σ((题目分数 / 测试数据对数) * r)

应用案例：暂无。

* 编辑距离匹配（按 错误行 扣分）  
基于编辑距离算法，按行对比学生输出与期望输出，假设不同的行数为 d， 错误一行扣分 r %

题目得分 = Σ((题目分数 / 测试数据对数) * MAX((1 - d * r%), 0) )

应用案例：在编译课程实验中的词法分析与语法分析，根据分析出来词法或者语法成分的比例得分。 避免精确匹配策略导致的完全零分的情况。

* 编辑距离匹配（按相似度得分）  
计算学生输出与期望输出的编辑距离，假设为 d， 学生输出长度为S，期望输出长度为E

题目得分 = Σ((题目分数 / 测试数据对数) * (1.0 - d / MAX(S, E)) )

应用案例：在编译课程实验中的词法分析与语法分析，根据分析出来词法或者语法成分的比例得分。 避免精确匹配策略导致的完全零分的情况。
